/*
ga_search.hh

This C++ header file defines the class GA_SEARCH_MODULE
It was generated with the RCS-Design tool.
Template Version 1.1

MODIFICATIONS:
Tue Dec 26 21:08:03 EST 2000	Modified by RCS-Design tool.
Tue Dec 26 20:43:05 EST 2000	Modified by RCS-Design tool.
Tue Dec 26 19:25:26 EST 2000	Modified by RCS-Design tool.
Tue Dec 26 17:34:23 EST 2000	Created by RCS-Design tool.

*/

// Prevent Multiple Inclusion
#ifndef GA_SEARCH_HH
#define GA_SEARCH_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "ga.hh" 	// CHROMOSOME,TRAITS, INDIVIDUAL, SURVIVOR, and POPULATION definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "ga_searchn.hh" 	// NML Commands and Status definitions for ga_search
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


class GA_SEARCH_MODULE: public NML_MODULE
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

public:

	GA_SEARCH_MODULE(int _is_base_class = 0); // Constructor

	// Overloaded Virtual Functions
	virtual void PRE_PROCESS();
	virtual void DECISION_PROCESS();
	virtual void POST_PROCESS();
	virtual void INITIALIZE_NML();

	// Command Functions
	virtual void INIT(GA_SEARCH_INIT *);
	virtual void HALT(GA_SEARCH_HALT *);
	virtual void EVOLVE(GA_SEARCH_EVOLVE *);
	virtual void GET_NEXT_GENERATION(GA_SEARCH_GET_NEXT_GENERATION *);
	virtual void SET_CROSSOVER_PROBABILITY(GA_SEARCH_SET_CROSSOVER_PROBABILITY *);
	virtual void SET_DECIMAL(GA_SEARCH_SET_DECIMAL *);
	virtual void SET_GENE_RANGE(GA_SEARCH_SET_GENE_RANGE *);
	virtual void SET_MUTATION_PROBABILITY(GA_SEARCH_SET_MUTATION_PROBABILITY *);
	virtual void SET_TRAIT_OFFSET(GA_SEARCH_SET_TRAIT_OFFSET *);
	virtual void SET_TRAIT_RANGE(GA_SEARCH_SET_TRAIT_RANGE *);
	virtual void SET_TRAIT_START(GA_SEARCH_SET_TRAIT_START *);
	virtual void SET_TYPE_CROSSOVER(GA_SEARCH_SET_TYPE_CROSSOVER *);
	virtual void SET_TYPE_DECODING(GA_SEARCH_SET_TYPE_DECODING *);
	virtual void SET_TYPE_ELITISM(GA_SEARCH_SET_TYPE_ELITISM *);

	// Convenience Variables
	GA_SEARCH_STATUS *ga_search_status;
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


private:
	// Add custom variables and functions here.
	int pop_size;
	int chrom_lenght;
	int num_traits;

	POPULATION *population;

};

#endif 	// GA_SEARCH_HH




